.286
.model small
.stack 100h

.DATA
Buffer           db 15h
KBuffer          dd 0

Phrase	         db 'Insert your password:',0,'$'
string	         db 'NetBus Base',0,'$'
Pass             db 15h dup (0)

.CODE

start:

        mov     ax,@data                ; Set segment register
        mov     ds, ax                 
        mov     es, ax
        call    AskPass                 ; Ask password
        mov     ah, 0Ah                 ; Get input
        mov     dx, offset Buffer       
        int     21h
        call    Crypt                   ; Crypt pass
        
exit:
        mov ah,4ch                      ; Exit
        int 21h


;-------------------------------------------
AskPass           proc
        mov  dx, offset Phrase          ; Print string
        mov  ah, 09h                    ; Visualize string
        int  21h
        ret
AskPass            endp
;-------------------------------------------

;-------------------------------------------
Crypt	proc
        xor si, si
        xor ax, ax
        mov cl, byte ptr[Kbuffer]
        mov bx, 41h                      ; 41h = A ----> bx = A
gogo:  	mov al, byte ptr[KBuffer+1+si]   ; A char of the pass in AL
        add bx, ax                       ; Add char to bx
        and bx, 80FFh                    ; Too big? Truncate
        jns go1
        dec bx
        or  bx, 0FF00h
        inc bx
go1:    cmp si, 0Bh		         ; B = string length
        jge go2                          ; Pass too long? Reinizialize counter
        inc si
        jmp go3
go2:    mov si, 1
go3:    mov al, byte ptr[string+si-1]    ; A char of "NetBus Base" string in AL
        xor bx, ax                       ; Generate pass
        mov byte ptr[Pass+si+1], bl      ; Move pass in the buffer
        dec cl
        test cl, cl
        jnz gogo                         ; Loop until pass is finished
	mov byte ptr[Pass+1], 41h
        int 3
	ret
Crypt	endp
;-------------------------------------------	

end start